set POVER=2.4.2
set POVERDLL=2.4

set ZIP="C:\Program Files\7-Zip\7z.exe" a -tzip -mx=5
set VCBUILD="C:\Program Files (x86)\Microsoft Visual Studio 11.0\Common7\IDE\WDExpress.exe"

cd /d %~dp0

rem Binaries
rmdir /S /Q "PngOptimizer-%POVER%"
mkdir PngOptimizer-%POVER%
chdir PngOptimizer-%POVER%
mkdir x64
chdir x64
mkdir PngOptimizer
mkdir PngOptimizerCL
mkdir PngOptimizerDll
chdir ..
mkdir x86
chdir x86
mkdir PngOptimizer
mkdir PngOptimizerCL
chdir ..

%VCBUILD% ../../Projects/PngOptimizer/PngOptimizer.sln       /build "Release|x64"   || goto Fail
%VCBUILD% ../../Projects/PngOptimizer/PngOptimizer.sln       /build "Release|Win32" || goto Fail
%VCBUILD% ../../Projects/PngOptimizerCL/PngOptimizerCL.sln   /build "Release|x64"   || goto Fail
%VCBUILD% ../../Projects/PngOptimizerCL/PngOptimizerCL.sln   /build "Release|Win32" || goto Fail
%VCBUILD% ../../Projects/PngOptimizerDll/PngOptimizerDll.sln /build "Release|x64"   || goto Fail

copy "../../Projects/PngOptimizer/x64-Release\PngOptimizer.exe"  "x64/PngOptimizer/" || goto Fail
copy "../../Projects/PngOptimizer\Readme.txt"                    "x64/PngOptimizer/" || goto Fail
copy "../../Projects/PngOptimizer\License.txt"                   "x64/PngOptimizer/" || goto Fail
copy "../../Projects/PngOptimizer\Changelog.txt"                 "x64/PngOptimizer/" || goto Fail

copy "../../Projects/PngOptimizer/Win32-Release\PngOptimizer.exe"  "x86/PngOptimizer/" || goto Fail
copy "x64/PngOptimizer\*.txt" "x86/PngOptimizer/"  || goto Fail

copy "../../Projects/PngOptimizerCL/x64-Release\PngOptimizerCL.exe"  "x64/PngOptimizerCL/" || goto Fail
copy "../../Projects/PngOptimizerCL\Readme.txt"                      "x64/PngOptimizerCL/" || goto Fail
copy "../../Projects/PngOptimizerCL\License.txt"                     "x64/PngOptimizerCL/" || goto Fail
copy "../../Projects/PngOptimizerCL\Changelog.txt"                   "x64/PngOptimizerCL/" || goto Fail

copy "../../Projects/PngOptimizerCL/Win32-Release\PngOptimizerCL.exe" "x86/PngOptimizerCL/" || goto Fail
copy "x64/PngOptimizerCL\*.txt" "x86/PngOptimizerCL/"  || goto Fail

copy "../../Projects/PngOptimizerDll/x64-Release\PngOptimizerDll.dll" "x64/PngOptimizerDll/" || goto Fail
copy "../../Projects/PngOptimizerDll/x64-Release\PngOptimizerDll.lib" "x64/PngOptimizerDll/" || goto Fail
copy "../../Projects/PngOptimizerDll\PngOptimizerDll.h"               "x64/PngOptimizerDll/" || goto Fail
copy "../../Projects/PngOptimizerDll\License.txt"                     "x64/PngOptimizerDll/" || goto Fail

rem Archives
del *.zip

rem Sources
rmdir /S /Q "PngOptimizer-sources"
mkdir PngOptimizer-sources
hg archive -X ../../Projects/kbdfr_dk ^
           -X ../../Projects/TestChu ^
           -X ../../Projects/ViewPicNG ^
           -X ../../SDK/chunet ^
           -X ../../SDK/chugfx          PngOptimizer-sources

copy "..\Readme-PngOptimizer-sources.txt" "PngOptimizer-sources/" || goto Fail

rem Copy additional files for PngOptimizerDll package
xcopy "PngOptimizer-sources/Projects/TestPODll" "x64/PngOptimizerDll/TestPODll" /S /I || goto Fail

%ZIP% "PngOptimizer-%POVER%-sources.zip" "PngOptimizer-sources"

cd x64
%ZIP% "../PngOptimizer-%POVER%-x64.zip"   "PngOptimizer"
%ZIP% "../PngOptimizerCL-%POVER%-x64.zip" "PngOptimizerCL"
%ZIP% "../PngOptimizerDll-%POVERDLL%-x64.zip" "PngOptimizerDll"
cd ..

cd x86
%ZIP% "../PngOptimizer-%POVER%-x86.zip"   "PngOptimizer"
%ZIP% "../PngOptimizerCL-%POVER%-x86.zip" "PngOptimizerCL"
cd ..
cd ..

@color A
@echo =
@echo =   SUCCESS
@echo =
@goto Exit

:Fail
@color C
@echo =
@echo =   FAILURE
@echo =
@goto Exit

:Exit
@pause
@color
